#include <stdio.h>
#include <string.h>

#define max(a, b) (a>b ? a : b)

char plocha[5][5];
char plocha2[5][5];
int pozice[5][5];

int n;

bool valid() {
  for (int i=0; i<n; i++)
    for (int j=0; j<n; j++) 
      if ((pozice[j][i]==1) && (plocha[j][i]=='X')) return false;
  return true;
}

void fill(int x, int y, int dx, int dy) {
  if (x<0 || x>=n || y<0 || y>=n) return;
//  printf("fill %d %d\n", x, y);
  if (plocha[y][x]!='.') return;
  plocha2[y][x]='*';
  fill(x+dx, y+dy, dx, dy);
}

bool ohrozujise() {
  memcpy(plocha2, plocha, 25);
  for (int i=0; i<n; i++)
    for (int j=0; j<n; j++) 
      if (pozice[j][i]==1) 
        if (plocha2[j][i]=='*') return true;
	else {
	  fill(i, j, 1, 0);
	  fill(i, j, -1, 0);
	  fill(i, j, 0, 1);
	  fill(i, j, 0, -1);	  
	}
  return false;
}


void alg() {
  for (int i=0; i<n; i++) scanf("%s", plocha[i]);
//  printf("-%d- ", n);

  int pocet=(1<<(n*n));
  int best=0;
  for (int idx=0; idx<pocet; idx++) {
    int kamenu=0;
    int x=idx;
    int i=0, j=0;
    while (1) {
      pozice[j][i]=(x%2);
      kamenu+=pozice[j][i];
      i++;
      if (i==n) {
        j++;
	if (j==n) break;
	i=0;
      }      
      x/=2;
    }

    if (best>=kamenu) continue;
    if (kamenu>(n*n+1)/2) continue;

    if (valid()) {
      if (!ohrozujise()) {
        best=kamenu;
      }
    }
  }
  printf("%d\n", best);  
}


int main() {
  scanf("%d\n", &n);
  while (n!=0) {
    alg();
    scanf("%d\n", &n);
  }
  return 0;  
}
